<?php

/*
+--------------------------------------------------------------------------
|   Download manager
|   ========================================
|   by Parmeet Singh (Improved By Ryan Ong)
|   (c) 2001,2002 IBForums
|   http://www.phpwiz.net
|   ========================================
|   Web: http://www.phpwiz.net
|   Email: parmeet@emirates.net.ae
|   IBFORUMS: Licence Info: phpib-licence@ibforums.com
+---------------------------------------------------------------------------
|
|   > Admin Forum function
|   > Module written by Parmeet
|   > Date started: 23th July 2002
|
|	> Module Version Number: 1.0.0
+--------------------------------------------------------------------------
*/


$idx = new ad_downloads();


class ad_downloads {

	var $base_url;

	function ad_downloads() {
		global $IN, $root_path, $INFO, $DB, $SKIN, $ADMIN, $std, $MEMBER, $GROUP;

		switch($IN['code'])
		{
		    case 'showaddcat':
				$this->show_cat('add');
				break;

			case 'showdelcat':
				$this->show_cat('del');
				break;

			case 'showeditcat':
				$this->show_cat('edit');
				break;

			case 'showeditcat1':
				$this->show_cat('edit1');
				break;

			case 'doaddcat':
				$this->do_cat('add');
				break;

			case 'dodelcat':
				$this->do_cat('del');
				break;

			case 'doeditcat':
				$this->do_cat('edit');
				break;

			case 'switch':
				$this->switch_download( );
				break;

			case 'settings':
				$this->show_edit_vars( );
				break;

			case 'do_switch':
				$this->save_config( array( 'd_section_close'));
				break;
				
            case 'editvars':
                $this->edit_vars( );
                break;
                
			case 'reorder':
				$this->reorder_form();
				break;

			case 'doreorder':
				$this->do_reorder();
				break;

            default:
				$this->main_screen( );
				break;
		}
		
	}

	
	//-------------------------------------------------------------
	//
	// Save config. Does the hard work, so you don't have to.
	//
	//--------------------------------------------------------------
	
	function save_config( $new )
	{
		global $IN, $root_path, $INFO, $DB, $SKIN, $ADMIN, $std, $MEMBER, $GROUP, $HTTP_POST_VARS;
		
		$master = array();
		
		if ( is_array($new) )
		{
			if ( count($new) > 0 )
			{
				foreach( $new as $field )
				{
				
					// Handle special..
					
					if ($field == 'img_ext' or $field == 'avatar_ext')
					{
						$HTTP_POST_VARS[ $field ] = preg_replace( "/[\.\s]/", "" , $HTTP_POST_VARS[ $field ] );
						$HTTP_POST_VARS[ $field ] = preg_replace( "/,/"     , '|', $HTTP_POST_VARS[ $field ] );
					}
					else if ($field == 'coppa_address')
					{
						$HTTP_POST_VARS[ $field ] = nl2br( $HTTP_POST_VARS[ $field ] );
					}
					
					$HTTP_POST_VARS[ $field ] = preg_replace( "/'/", "&#39;", stripslashes($HTTP_POST_VARS[ $field ]) );
				
					$master[ $field ] = stripslashes($HTTP_POST_VARS[ $field ]);
				}
				
				$ADMIN->rebuild_config($master);
			}
		}
		
		$ADMIN->save_log("Board Downloads Updated, Back Up Written");
		
		$ADMIN->done_screen("Download Configuration Updated", "Administration CP Home", "act=index" );
		
		
		
	}

 
 	function show_cat( $type = "add" ) {
		global $IN, $root_path, $INFO, $DB, $SKIN, $ADMIN, $std, $MEMBER, $GROUP;

		if( $type == "add" ) {
			$a_array   = array( );
			$a_array[] = array( 1 , "Yes" );
			$a_array[] = array( 0 , "No" );

			$s_array   = array( );
			$s_array[] = array( 1 , "Yes" );
			$s_array[] = array( 0 , "No" );

			$as_array   = array( );
			$as_array[] = array( 1 , "Yes" );
			$as_array[] = array( 0 , "No" );

			$DB->query( "SELECT * from ibf_cats WHERE sub = 0" );
			$e_array   = array( );
			$e_array[] = array( 0 , "None" );
			while( $row = $DB->fetch_row( ) ) {
				$e_array[] = array( $row['id'] , $row['cname'] );

			}

		$DB->query( "SELECT * FROM ibf_forums" );
		$tt_array   = array( );
		$tt_array[] = array( 0 , "<b>None</b>" );
		while( $row = $DB->fetch_row( ) ) {
			$tt_array[] = array( $row['id'] , "--{$row['name']}" );

		}


			$ADMIN->page_title = "Adding a download category!";

			$ADMIN->page_detail = "This page helps you add categories for your download page.";

			//+-------------------------------

			$ADMIN->html .= $SKIN->start_form( array( 1 => array( 'code'  , 'doaddcat' ),
													  2 => array( 'act'   , 'downloads'     ),
									     	)      );

			$ADMIN->html .= $SKIN->start_table( "Add Category" );

			$ADMIN->html .= $SKIN->add_td_row( array( "<b>Name</b>" ,
													  $SKIN->form_input("name","","text"),
									 	    )      );

			$ADMIN->html .= $SKIN->add_td_row( array( "<b>Description</b>" ,
													  $SKIN->form_input("desc","","text"),
											     )      );

			$ADMIN->html .= $SKIN->add_td_row( array( "<b>Do you want screenshots to automautically display in this category??</b><br>--Note: If you have set this globally to Yes or No, this setting is ignored." ,
													  $SKIN->form_dropdown("dis_screen",$s_array,"text"),
											     )		);

			$ADMIN->html .= $SKIN->add_td_row( array( "<b>Do you want to accept files in this category before being available for download??</b><br>--Note: If you have set this globally to Yes or No, this setting is ignored." ,
													  $SKIN->form_dropdown("authorize",$as_array,"text"),
											     )		);

			$ADMIN->html .= $SKIN->add_td_row( array( "<b>In which forum do you wish for files submitted to this category to automautically create a topic?</b><br />--Note: If this has a global setting other than \"Per-Category\" this setting will be ignored." ,
												  $SKIN->form_dropdown("fordaforum",$tt_array,"text"),
											    )		);


			$ADMIN->html .= $SKIN->add_td_row( array( "<b>Do you want this category to be open??</b>" ,
													  $SKIN->form_dropdown("open",$a_array,"text"),
											     )		);

			$ADMIN->html .= $SKIN->add_td_row( array( "<b>Choose the category of which this category should be a sub category of.</b><br>If you do not want this category to be sub category then choose 'None'" ,
													  $SKIN->form_dropdown("sub",$e_array,"text"),
									 	    )      );

			$ADMIN->html .= $SKIN->end_form("Add Category");

			$ADMIN->html .= $SKIN->end_table( );

			$ADMIN->output( );
			}
		elseif( $type == "del" ) {

			$ADMIN->page_title = "Deleting categories!";

			$ADMIN->page_detail = "This page helps you delete categories.";


			$DB->query( "SELECT * from ibf_cats" );
			$d_array   = array( );
			$w_array   = array( );

			while( $row = $DB->fetch_row( ) ) {
				$d_array[] = array( $row['id'] , $row['cname'] );
				$w_array[] = array( $row['id'] , $row['cname'] );
			}
			//+-------------------------------

			$ADMIN->html .= $SKIN->start_form( array( 1 => array( 'code'  , 'dodelcat' ),
													  2 => array( 'act'   , 'downloads'     ),
									     	)      );

			$ADMIN->html .= $SKIN->start_table( "Delete Category" );

			$ADMIN->html .= $SKIN->add_td_row( array( "<b>Choose which category to delete</b>" ,
													  $SKIN->form_dropdown("del",$d_array,"text"),
									 	    )      );

			$ADMIN->html .= $SKIN->add_td_row( array( "<b>To which category would you like to transfer the scripts belonging to this category</b>" ,
													  $SKIN->form_dropdown("trans",$w_array,"text"),
											     )      );

			$ADMIN->html .= $SKIN->end_form("Delete Category");

			$ADMIN->html .= $SKIN->end_table( );

			$ADMIN->output( );
		}
		elseif( $type == "edit" ) {

			$ADMIN->page_title = "Editing download categories!";

			$ADMIN->page_detail = "This page helps you edit caegories for your download page.";


			$DB->query( "SELECT * from ibf_cats" );
			$e_array   = array( );


			while( $row = $DB->fetch_row( ) ) {
				$e_array[] = array( $row['id'] , $row['cname'] );
			}
			//+-------------------------------

			$ADMIN->html .= $SKIN->start_form( array( 1 => array( 'code'  , 'showeditcat1' ),
													  2 => array( 'act'   , 'downloads'     ),
									     	)      );

			$ADMIN->html .= $SKIN->start_table( "Edit Categories" );

			$ADMIN->html .= $SKIN->add_td_row( array( "<b>Choose which category to edit</b>" ,
													  $SKIN->form_dropdown("id",$e_array,"text"),
									 	    )      );

			$ADMIN->html .= $SKIN->end_form("Edit Category");

			$ADMIN->html .= $SKIN->end_table( );

			$ADMIN->output( );

		}
		elseif( $type == "edit1" ) {

			if( $IN['id'] == "" ) {
				$ADMIN->error("No category was specified...");
			}

			$DB->query( "SELECT * from ibf_cats WHERE sub = 0" );
			$e_array   = array( );
			$e_array[] = array( 0 , "None" );
			while( $row = $DB->fetch_row( ) ) {
				$e_array[] = array( $row['id'] , $row['cname']);

			}

		$DB->query( "SELECT * FROM ibf_forums" );
		$tt_array   = array( );
		$tt_array[] = array( 0 , "<b>None</b>" );
		while( $row = $DB->fetch_row( ) ) {
			$tt_array[] = array( $row['id'] , "--{$row['name']}" );

		}


			$ADMIN->page_title = "Editing download categories!";

			$ADMIN->page_detail = "This page helps you edit caegory for your download module.";


			$DB->query( "SELECT * FROM ibf_cats WHERE id = " . $IN['id'] );

			$row = $DB->fetch_row( );



			$auth = $row['authorize'] == 1 ? 1 : 0;
			$dis = $row['dis_screen'] == 1 ? 1 : 0;

			$open = $row['open'] == 1 ? 1 : 0;
			//+-------------------------------

			$ADMIN->html .= $SKIN->start_form( array( 1 => array( 'code'  , 'doeditcat' ),
													  2 => array( 'act'   , 'downloads' ),
									     	)      );
			$a = array( );
			$a[] = array('id', $IN['id']);


			$ADMIN->html .= $SKIN->form_hidden($a);

			$ADMIN->html .= $SKIN->start_table( "Edit Categories" );

			$ADMIN->html .= $SKIN->add_td_row( array( "<b>Name</b>" ,
													  $SKIN->form_input("name",$row['cname'],"text"),
									 	    )      );

			$ADMIN->html .= $SKIN->add_td_row( array( "<b>Description</b>" ,
													  $SKIN->form_input("desc",$row['cdesc'],"text"),
									 	    )      );

			$ADMIN->html .= $SKIN->add_td_row( array( "<b>Do you screenshots to automautically display in this category?</b><br>--Note: If you have set this globally to Yes or No, this setting is ignored." ,
													  $SKIN->form_yes_no("dis_screen", $dis),
									 	    )      );

			$ADMIN->html .= $SKIN->add_td_row( array( "<b>Do you want to accept files in this category before being available to the public?</b><br>--Note: If you have set this globally to Yes or No, this setting is ignored." ,
													  $SKIN->form_yes_no("authorize", $auth),
									 	    )      );

		$ADMIN->html .= $SKIN->add_td_row( array( "<b>In which forum do you wish for files submitted to this category to automautically create a topic?</b><br />--Note: If this has a global setting other than \"Per-Category\" this setting will be ignored." ,
												  $SKIN->form_dropdown("fordaforum",$tt_array, $row['fordaforum']),
											    )		);


			$ADMIN->html .= $SKIN->add_td_row( array( "<b>Choose the category of which this category should be a sub category of.</b><br>If you do not want this category to be sub category then choose 'None'" ,
													  $SKIN->form_dropdown("sub",$e_array,$row['sub']),
									 	    )      );

			$ADMIN->html .= $SKIN->add_td_row( array( "<b>Do you want this category to be open?</b>" ,
													  $SKIN->form_yes_no("open", $open),
									 	    )      );

			$ADMIN->html .= $SKIN->end_form("Edit Category");

			$ADMIN->html .= $SKIN->end_table( );

			$ADMIN->output( );

		}
	}
	//+---------------------------------------------------------------------------------
	//
	// RE-ORDER CATEGORY
	//
	//+---------------------------------------------------------------------------------
	function reorder_form() {
		global $IN, $root_path, $INFO, $DB, $SKIN, $ADMIN, $std, $MEMBER, $GROUP;

		$ADMIN->page_title = "Category Re-Order";
		$ADMIN->page_detail  = "To re-order the categories, simply choose the position number from the drop down box next to each category title.  When you are satisfied with the ordering, simply hit the submit button at the bottom of the form.";

		$ADMIN->html .= $SKIN->start_form( array( 1 => array( 'code'  , 'doreorder'),
									2 => array( 'act'   , 'downloads'     ),
											) );


		$SKIN->td_header[] = array( "&nbsp;"       , "10%" );
		$SKIN->td_header[] = array( "Category Name"   , "90%" );

		$ADMIN->html .= $SKIN->start_table( "Your Categories" );

		$cats   = array();

		$DB->query("SELECT * from ibf_cats WHERE id > 0 ORDER BY position ASC");
		while ($r = $DB->fetch_row())
		{
			$cats[] = $r;
		}


		// Build up the drop down box

		$form_array = array();

		for ($i = 1 ; $i <= count($cats) ; $i++ )
		{
			$form_array[] = array( $i , $i );
		}


		$last_cat_id = -1;

		foreach ($cats as $c)
		{

			$ADMIN->html .= $SKIN->add_td_row( array(  $SKIN->form_dropdown( 'POS_'.$c['id'], $form_array, $c['position'] ),
													   $c['cname'],
											 ), 'catrow'     );
			$last_cat_id = $c['id'];




				if ($r['category'] == $last_cat_id)
				{
					$ADMIN->html .= $SKIN->add_td_row( array(
															   '&nbsp;',
															   "<b>".$r['cname']."</b><br>".$r['cdesc'],
															   $r['posts'],
															   $r['topics'],
													 )      );
				}
				}

		$ADMIN->html .= $SKIN->end_form("Adjust Category Ordering");

		$ADMIN->html .= $SKIN->end_table();

		$ADMIN->output();

	}

	//+---------------------------------------------------------------------------------

	function do_reorder() {
		global $IN, $root_path, $INFO, $DB, $SKIN, $ADMIN, $std, $MEMBER, $GROUP;

		$cat_query = $DB->query("SELECT id from ibf_cats");

		while ( $r = $DB->fetch_row($cat_query) )
		{
			$order_query = $DB->query("UPDATE ibf_cats SET position='".$IN[ 'POS_' . $r['id'] ]."' WHERE id='".$r['id']."'");
		}

		$ADMIN->done_screen("Category Ordering Adjusted", "Category Control", "act=cat" );
		
		
	}
	function do_cat( $type = "add" ) {

		global $IN, $root_path, $INFO, $DB, $SKIN, $ADMIN, $std, $MEMBER, $GROUP;

		if( $type == "add" ) {
			if( $IN['name'] == "" ) {
				$ADMIN->error("The name field was not filled in...");
			}
			elseif( $IN['desc'] == "" ) {
				$ADMIN->error("The description field was not filled in...");
			}
			elseif( $IN['open'] == "" ) {
				$ADMIN->error("The open field was not filled in...");
			}

			$DB->query( "SELECT MAX(id) as mid FROM ibf_cats" );
			$row = $DB->fetch_row( );

			$last_id = $row['mid'] + 1;
			if( $IN['sub'] == 0 || $IN['sub'] == "" ) {
				$DB->query( "SELECT cname FROM ibf_cats WHERE cname = '" . $IN['name'] . "' AND sub = 0" );
			}
			else {
				$DB->query( "SELECT cname FROM ibf_cats WHERE cname = '" . $IN['name'] . "' AND sub = '" . $IN['sub'] . "'" );
			}

			if( $DB->get_num_rows( ) > 0 ) {
				$ADMIN->error("Duplicate category name...");
			}

			$DB->query( "SELECT id FROM ibf_cats WHERE id = '" . $IN['sub'] . "' AND sub != 0" );

			if( $DB->get_num_rows( ) > 0 ) {
				$ADMIN->error("The ID specified for the category does not exists or that category is already a sub category...");
			}

			$DB->query( "INSERT INTO ibf_cats ( id , sub , cname , cdesc , open, dis_screen, authorize, fordaforum ) VALUES( '$last_id' , '" . $IN['sub'] . "' , '" . $IN['name'] . "' , '" . $IN['desc'] . "' , '" . $IN['open'] . "', '" . $IN['dis_screen'] . "', '" . $IN['authorize'] ."', '" . $IN['fordaforum'] ."'  )" );

			$ADMIN->done_screen("Category created!", "Download Admin", "act=downloads" );
		}
		if( $type == "edit" ) {
			if( $IN['id'] == "" ) {
				$ADMIN->error("No category specified...");
			}
			elseif( $IN['name'] == "" ) {
				$ADMIN->error("No name specified...");
			}
			elseif( $IN['desc'] == "" ) {
				$ADMIN->error("No description specified...");
			}
			elseif( $IN['open'] == "" ) {
				$ADMIN->error("You did not specify whether you want the category to be open or not...");
			}

			$DB->query( "UPDATE ibf_cats SET cname = '" . $IN['name'] . "' , sub = '" . $IN['sub'] . "' , cdesc = '" . $IN['desc'] . "' , open = '" . $IN['open'] . "', dis_screen = '" . $IN['dis_screen'] . "', authorize = '" .$IN['authorize'] . "', fordaforum = '" . $IN['fordaforum'] . "'  WHERE id = " . $IN['id'] );

			$ADMIN->done_screen("Category edited!", "Download Admin", "act=downloads" );
		}
		if( $type == "del" ) {
			if( $IN['del'] == "" ) {
				$ADMIN->error("No category specified...");
			}
			if( $IN['trans'] == "" ) {
				$ADMIN->error("The category to which the files in this category must be transfered isnt specified...");
			}
			$DB->query( "UPDATE ibf_scripts SET cat = '" . $IN['trans'] . "' WHERE cat = '" . $IN['del'] . "'" );
			$DB->query( "DELETE FROM ibf_cats WHERE id = '" . $IN['del'] . "'" );

			$ADMIN->done_screen("Category deleted and files have been tranfered!", "Download Admin", "act=downloads" );
		}
	}

	function switch_download( ) {
		global $IN, $root_path, $INFO, $DB, $SKIN, $ADMIN, $std, $MEMBER, $GROUP;
        if (!$INFO['d_section_close']) {
            $status = "On";
        } else {
            $status = "Off";
        }
        $ADMIN->page_title   = "Download Settings (Downloads offline/online)";
        $ADMIN->page_detail  = "Downloads are ".$status;
		$ADMIN->html .= $SKIN->start_form( array( 1 => array( 'code'  , 'do_switch' ),
												  2 => array( 'act'   , 'downloads'     ),
									     )      );

		$ADMIN->html .= $SKIN->start_table( "Settings" );

		$ADMIN->html .= $SKIN->add_td_row( array( "<b>Do you want to set the download section offline?</b>" ,
												  $SKIN->form_yes_no("d_section_close", $INFO['d_section_close'] )
									     )      );
		$ADMIN->html .= $SKIN->end_form("Edit downloads");

		$ADMIN->html .= $SKIN->end_table( );

		$ADMIN->output( );
	}

	function show_edit_vars(  ) {
		global $IN, $root_path, $INFO, $DB, $SKIN, $ADMIN, $std, $MEMBER, $GROUP;
		$o_array   = array( );
		$o_array[] = array( 1 , "Yes" );
		$o_array[] = array( 0 , "No" );

		$ADMIN->page_title = "Editing download section's configuration!";

		$ADMIN->page_detail = "This page lets you edit the configuration for the download section.";

		//+-------------------------------

		$ADMIN->html .= $SKIN->start_form( array( 1 => array( 'code'  , 'editvars' ),
												  2 => array( 'act'   , 'downloads'     ),
									     )      );

		$ADMIN->html .= $SKIN->start_table( "Edit configuration" );
		$max_size=ini_get('upload_max_filesize');
		$ADMIN->html .= $SKIN->add_td_row( array( "<b>What must be the maximum size of files that can be uploaded?</b><br />Your php.ini upload_max_filesize is set to ".$max_size."<br />In KB(KiloBytes)" ,
												  $SKIN->form_input("d_max_dwnld_size",$INFO['d_max_dwnld_size'],"text"),
											    )		);

		$ADMIN->html .= $SKIN->add_td_row( array( "<b>What must be the maximum size of screenshots that can be uploaded?</b><br>In KB(KiloBytes)" ,
												  $SKIN->form_input("d_screen_max_dwnld_size",$INFO['d_screen_max_dwnld_size'],"text"),
											    )		);

		$ADMIN->html .= $SKIN->add_td_row( array( "<b>What is the path to the download directory?</b>" ,
												  $SKIN->form_input("d_download_dir",$INFO['d_download_dir'],"text"),
											    )		);

		$ADMIN->html .= $SKIN->add_td_row( array( "<b>What is the path to the screenshots directory?</b>" ,
												  $SKIN->form_input("d_screen_dir",$INFO['d_screen_dir'],"text"),
											    )		);

		$ADMIN->html .= $SKIN->add_td_row( array( "<b>What is the url to the download directory?</b>" ,
												  $SKIN->form_input("d_download_url",$INFO['d_download_url'],"text"),
											    )		);

		$ADMIN->html .= $SKIN->add_td_row( array( "<b>What is the url to the screenshots directory?</b>" ,
												  $SKIN->form_input("d_screen_url",$INFO['d_screen_url'],"text"),
											    )		);
		// Reconvert array into a text string
		$dext = "";
        foreach( $INFO['d_allowable_ext'] as $value){
            $dext .= $value."|";
        }
        $dext = substr($dext ,0 ,-1);	
		$ADMIN->html .= $SKIN->add_td_row( array( "<b>What are the allowable file extensions for downloads?</b><br>Must be seperated by '|' eg \".txt|.zip\"" ,
												  $SKIN->form_input("d_allowable_ext",$dext,"text"),
											    )		);
		// Reconvert array into a text string
		$sext = "";
        foreach( $INFO['d_screenshot_ext'] as $value){
            $sext .= $value."|";
        }
        $sext = substr($sext ,0 ,-1);	
		$ADMIN->html .= $SKIN->add_td_row( array( "<b>What are the allowable file extensions for screen shots?</b><br>Must be seperated by '|' eg \".gif|.jpeg\"<br>Leave it blank if you want to disable screen shots!" ,
												  $SKIN->form_input("d_screenshot_ext",$sext,"text"),
											    )		);

        $ADMIN->html .= $SKIN->add_td_row( array( "<b>Do you want Anti-Leech Active?</b>" ,
												  $SKIN->form_yes_no("d_anti_leech",$INFO['d_anti_leech'] ),
											    )		);

        $ADMIN->html .= $SKIN->add_td_row( array( "<b>What file would you like to store leechers in?(ex. leech.txt.)</b>" ,
												  $SKIN->form_input("d_log",$INFO['d_log'] ),
											    )		);

        $ADMIN->html .= $SKIN->add_td_row( array( "<b>Do you want Force Download Active?(This increases file security greatly and also renames the files correctly.)</b>" ,
												  $SKIN->form_yes_no("d_force",$INFO['d_force'] ),
											    )		);

		$ADMIN->html .= $SKIN->add_td_row( array( "<b>What is the Bandwidth limit?(How fast somebody can download in Kb/s. Force Download must be on. For no limit put 0.)</b>" ,
												  $SKIN->form_input("d_speed",$INFO['d_speed'],"text"),
											    )		);
																								
        $ADMIN->html .= $SKIN->add_td_row( array( "<b>Do you want to upload files to the current server?</b>" ,
												  $SKIN->form_yes_no("d_current",$INFO['d_current'] ),
											    )		);
											    
		$ADMIN->html .= $SKIN->add_td_row( array( "<b>Do you want to have linking downloads?<br>(Download files from external servers... Please do not leech)</b>" ,
												  $SKIN->form_yes_no("d_linking", $INFO['d_linking'] )
									            )      );
											    
		$ADMIN->html .= $SKIN->add_td_row( array( "<b>What is the default number of files to show per page?</b>" ,
												  $SKIN->form_input("d_perpage",$INFO['d_perpage'],"text"),
											    )		);

        $ADMIN->html .= $SKIN->add_td_row( array( "<b>Do you wish to add \"[category name]\" to the topic title?</b><br />This only applies if you set the script to automautically create a topic on new submissions." ,
												  $SKIN->form_yes_no("d_cat_add",$INFO['d_cat_add'] ),
											    )		);
                                                									
        $ADMIN->html .= $SKIN->add_td_row( array( "<b>Do you want to show the number of files a member has submitted in topics?</b>" ,
												  $SKIN->form_yes_no("d_topic",$INFO['d_topic'] ),
											    )		);
		$ADMIN->html .= $SKIN->add_td_row( array( "<b>Do you want to show the number of downloads a member has downloaded in topics?</b>" ,
												  $SKIN->form_yes_no("d_downloads",$INFO['d_downloads'] ),
												)       );

		//-----------------------------------------------------------------------------------------------------------						 
		
		$ADMIN->html .= $SKIN->end_table( );
		$ADMIN->html .= $SKIN->start_table("Global vs Per-Category Settings");
		
		//-----------------------------------------------------------------------------------------------------------


		$ds_array   = array( );
		$ds_array[] = array( 1 , "Yes" );
		$ds_array[] = array( 0 , "No" );
		$ds_array[] = array( 2 , "Per-Category" );

		$as_array   = array( );
		$as_array[] = array( 1 , "Yes" );
		$as_array[] = array( 0 , "No" );
		$as_array[] = array( 2 , "Per-Category" );


		$DB->query( "SELECT * FROM ibf_forums" );
		$e_array   = array( );
		$e_array[] = array( 0 , "<b>None</b>" );
		$e_array[] = array( 'percat' , "<b>Per-Category</b>" );
		while( $row = $DB->fetch_row( ) ) {
			$e_array[] = array( $row['id'] , "--{$row['name']}" );

		}



		$ADMIN->html .= $SKIN->add_td_basic( 'If you would like the setting to be for all categories, choose a global answer (eg. yes, no, or a specific topic).<br>&nbsp;&nbsp;If you would like to configure these settings on a per-category basis, choose Per-Category.', 'left', 'catrow2' );


 		$ADMIN->html .= $SKIN->add_td_row( array( "<b>Do you want to accept files before being available for downloading?" ,
												  $SKIN->form_dropdown("d_authorize",$as_array,$INFO['d_authorize'] )
									     )      );

		$ADMIN->html .= $SKIN->add_td_row( array( "<b>Would you like to display screenshots automautically?</b>" ,
												  $SKIN->form_dropdown("d_dis_screen",$ds_array,$INFO['d_dis_screen']),
											    )		);

		$ADMIN->html .= $SKIN->add_td_row( array( "<b>If you want a topic to be created for each download submitted then choose the forum name.</b><br>If you do not want a topic created, choose none, or if you'd like to configure this on a per category basis, choose \"Per-Category\"" ,
												  $SKIN->form_dropdown("d_create_topic",$e_array,$INFO['d_create_topic']),
											    )		);
		$ADMIN->html .= $SKIN->end_table( );


		$ADMIN->html .= $SKIN->end_form("Edit downloads");

		$ADMIN->output( );
	}

	function edit_vars( ) {
		global $IN, $root_path, $INFO, $DB, $SKIN, $ADMIN, $std, $MEMBER, $GROUP, $HTTP_POST_VARS;

		if( $IN['d_max_dwnld_size'] == "" ) {
			$ADMIN->error("You did not specify the maximum upload size...");
		}
		elseif( $IN['d_download_dir'] == "" ) {
			$ADMIN->error("You did not specify the download directory...");
		}
		elseif( $IN['d_download_url'] == "" ) {
			$ADMIN->error("You did not specify the download url...");
		}
		elseif( $IN['d_allowable_ext'] == "" ) {
			$ADMIN->error("You did not specify the allowable file extensions...");
		}
		$content = "<?php\n";
		$allow1 = preg_replace( "/&#124;/", "|", stripslashes($HTTP_POST_VARS['d_allowable_ext']) );
		$allow1 = explode('|',$allow1);
		$allowable = "";
        foreach( $allow1 as $value){
            $allowable .= "'".strtolower($value)."', ";
        }
        $allowable = substr($allowable ,0 ,-2);
		$content .= "\$INFO['d_allowable_ext']         = array($allowable);\n";
		$screen = preg_replace( "/&#124;/", "|", stripslashes($HTTP_POST_VARS['d_screenshot_ext']) );
		$screen = explode('|',$screen);
		$screenshot = "";
        foreach( $screen as $value){
            $screenshot .= "'".$value."', ";
        }
        $screenshot = substr($screenshot ,0 ,-2);
		$content .= "\$INFO['d_screenshot_ext']        	= array({$screenshot});\n";
		$content .= "\$INFO['d_max_dwnld_size']        	= {$IN['d_max_dwnld_size']};\n";
		$content .= "\$INFO['d_screen_max_dwnld_size'] 	= {$IN['d_max_dwnld_size']};\n";
		$content .= "\$INFO['d_download_dir']          	= '{$IN['d_download_dir']}';\n";
		$content .= "\$INFO['d_download_url']          	= '{$IN['d_download_url']}';\n";
		$content .= "\$INFO['d_screen_dir']            	= '{$IN['d_screen_dir']}';\n";
		$content .= "\$INFO['d_screen_url']            	= '{$IN['d_screen_url']}';\n";
		$content .= "\$INFO['d_authorize']		      = {$IN['d_authorize']};\n";
		$content .= "\$INFO['d_anti_leech']               	= '{$IN['d_anti_leech']}';\n";
		$content .= "\$INFO['d_log']               	= '{$IN['d_log']}';\n";
		$content .= "\$INFO['d_speed']               	= '{$IN['d_speed']}';\n";
		$content .= "\$INFO['d_force']               	= {$IN['d_force']};\n";
		$content .= "\$INFO['d_linking']               	= {$IN['d_linking']};\n";
		$content .= "\$INFO['d_current']               	= {$IN['d_current']};\n";
		$content .= "\$INFO['d_perpage']		      = '{$IN['d_perpage']}';\n";
		$content .= "\$INFO['d_create_topic']		= '{$IN['d_create_topic']}';\n";
		$content .= "\$INFO['d_topic']                 	= {$IN['d_topic']};\n";
		$content .= "\$INFO['d_downloads']			= {$IN['d_downloads']};\n";
		$content .= "\$INFO['d_dis_screen']			= {$IN['d_dis_screen']};\n";
		$content .= "\$INFO['d_cat_add']			= {$IN['d_cat_add']};\n";
		$content .= "?".">\n";

		$open = fopen( $root_path."downloads_config.php" , "w" );
		fwrite( $open , $content );
		fclose( $open );

		$ADMIN->done_screen("Settings have been edited successfully", "Download Admin", "act=downloads" );
	}
	

	function main_screen( ) {
		global $IN, $root_path, $INFO, $DB, $SKIN, $ADMIN, $std, $MEMBER, $GROUP;

		$DB->query( "SELECT id FROM ibf_cats" );
		$cats 	 = $DB->get_num_rows( );

		$DB->query( "SELECT id FROM ibf_scripts" );
		$scripts = $DB->get_num_rows( );

		$DB->query( "SELECT DISTINCT author FROM ibf_scripts" );

		$authors = "";

		while( $row = $DB->fetch_row( ) ) {
			if( $authors == "" ) {
				$authors .= $row['author'];
			}
			else {
				$authors .= " , " . $row['author'];
			}
		}

		$DB->query( "SELECT SUM( downloads ) as down FROM ibf_scripts" );
		$downs	 = $DB->fetch_row( );

		$DB->query( "SELECT sname FROM ibf_scripts ORDER BY downloads DESC LIMIT 0,1" );
		$maxd	 = $DB->fetch_row( );

		$DB->query( "SELECT sname FROM ibf_scripts ORDER BY views DESC LIMIT 0,1" );
		$maxv	 = $DB->fetch_row( );

		$ADMIN->page_title = "Welcome to the downloads module's Control Panel!";

		$ADMIN->page_detail = "This page lets you control the download section.";

		//+-------------------------------
		$SKIN->td_header[] = array( "&nbsp;", "50%" );
		$SKIN->td_header[] = array( "&nbsp;", "50%" );
		$ADMIN->html .= $SKIN->start_table( "Download Module Admin Page" );

		$ADMIN->html .= $SKIN->add_td_row( array( "<b>Number of categories</b>" , $cats)      );

		$ADMIN->html .= $SKIN->add_td_row( array( "<b>Number of files</b>" , $scripts)		);

		$ADMIN->html .= $SKIN->add_td_row( array( "<b>Number of downloads</b>" , $downs['down'])		);

		$ADMIN->html .= $SKIN->add_td_row( array( "<b>Individual authors</b>" ,$authors
											    )		);

		$ADMIN->html .= $SKIN->add_td_row( array( "<b>File with highest number of downloads</b>" ,
												  $maxd['sname']
											    )		);

		$ADMIN->html .= $SKIN->add_td_row( array( "<b>File with highest number of views</b>" ,
												  $maxv['sname']
											    )		);

		$ADMIN->html .= $SKIN->end_table();

		$ADMIN->output();

	}
}


?>
